Bomb HDU - 3555 数位dp】的更多相关文章

Code: #include<cstdio> #include<algorithm> #include<cstring> #include<string> #include<iostream> using namespace std; #define ll long long #define N 20 ll f[N][4], str; int arr[N],n; void get_table(){ f[0][0]=1; for(int i=1;i…
Bomb Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 131072/65536 K (Java/Others)Total Submission(s): 15072    Accepted Submission(s): 5441 Problem Description The counter-terrorists found a time bomb in the dust. But this time the terrorists…
开始想用dp[i][j]来记录第i位j开头含有49的数的个数 但是init后并不知道如何进行cal 想了想可以用不要62的思想 当作不要49来做 然后减一下 就好 看网上的代码 不要62和这道题用的dp方法和cal都与我用的有很大不同 做完入门水题就去学习一下那种很正规的方法~ #include<stdio.h> #include<string.h> #include<algorithm> #include<map> #include<math.h&g…
#include<stdio.h> #define N 20 long long  dp[N][3]; void init(){ long long  i; dp[0][0]=1; for(i=1;i<=20;i++) {     dp[i][0]=dp[i-1][0]*10-dp[i-1][1];//没有考虑前导零的情况     dp[i][1]=dp[i-1][0];     dp[i][2]=dp[i-1][2]*10+dp[i-1][1]; } } long long  slov…
Bomb HDU - 3555 (数位DP) The counter-terrorists found a time bomb in the dust. But this time the terrorists improve on the time bomb. The number sequence of the time bomb counts from 1 to N. If the current number sequence includes the sub-sequence "49&…
Bomb HDU - 3555 求1~n中含有49数的个数 #include<bits/stdc++.h> #define LL long long using namespace std; LL T,x,dp[][],shu[]; LL dfs(LL pos,LL x,bool ok,bool limit){ if(!pos) return ok; if(!limit&&dp[pos][x]) return dp[pos][x]; LL cnt=,up=limit?shu[p…
http://acm.hdu.edu.cn/showproblem.php?pid=4507 Problem Description 单身! 依旧单身! 吉哥依旧单身! DS级码农吉哥依旧单身! 所以.他生平最恨情人节,无论是214还是77.他都讨厌! 吉哥观察了214和77这两个数,发现: 2+1+4=7 7+7=7*2 77=7*11 终于,他发现原来这一切归根究竟都是由于和7有关!所以,他如今甚至讨厌一切和7有关的数. 什么样的数和7有关呢? 假设一个整数符合以下3个条件之中的一个.那么我…
XHXJ's LIS Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 2265    Accepted Submission(s): 927 Problem Description #define xhxj (Xin Hang senior sister(学姐)) If you do not know xhxj, then careful…
题目:http://acm.hdu.edu.cn/showproblem.php?pid=3555 题意: 给出一个正整数N,求出1~N中含有数字“49”的数的个数 思路: 采用数位dp的状态转移方程法解 具体如下: dp[len][state];  dp数组的第一位代表数字的位数,第二位代表状态 状态设定: dp[i][0] : i 位数字中不含数字49的数的个数 dp[i][1] : i 位数字中不含数字49,但高位是9的数的个数 dp[i][0] : i 位数字中含有数字49的数的个数 状…
题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=6156 题意:如题. 解法:数位DP,暴力枚举进制之后,就转化成了求L,R区间的回文数的个数,这个直接做一个数位DP就好了.dp[jz][start][cur][state]表示jz进制下以start位起始到cur位状态为state(1表示已经回文,0表示没有回文)时回文数的个数. #include <bits/stdc++.h> using namespace std; typedef long…